xrandr --scale (again) confines mouse to native solution

Bug #1580123 reported by fish on 2016-05-10
46
This bug affects 7 people
Affects Status Importance Assigned to Milestone
X.Org X server
Fix Released
High
xorg-server (Ubuntu)
Medium
Unassigned

Bug Description

This might be a regression where the original issue is: https://bugs.launchpad.net/xorg-server/+bug/883319

It can be easily reproduced by doing something like:

    xrandr --output DP1 --scale 1.25x1.25

The mouse will be still constrained to the native solution (aka you can't move the mouse outside a box of whatever DP1 had as resolution before.

$ lsb_release -rd
Description: Ubuntu 16.04 LTS
Release: 16.04

$ xrandr --version
xrandr program version 1.5.0
Server reports RandR version 1.5

$ apt-cache policy xserver-xorg-core
xserver-xorg-core:
  Installed: 2:1.18.3-1ubuntu2

Filing this bug to facilitate the fix entering the pipeline

CRTC bound checking was introduced to make sure windows do not slide into hidden areas, when multiple screens map to the framebuffer. It seems to be interfering with Panning.

Description:
Panning does not work. The screen should pan when the mouse is moved outside the visible area on the screen, when the visible part of the screen on the CRTC is part of a larger configured framebuffer screen.

Use the following to configure panning
  xrandr --fb 1600x1200 --output LVDS --mode 1280x800 --panning 1600x1200
Use the following to restore
  xrandr --fb 1280x800 --output LVDS --mode 1280x800 --panning 1280x800
Move the mouse to the CRTC edge and expect to see screen to pan, but pan does not happen, because the mouse is constrained to remain in the CRTC bounds.

Use case:
laptops have small screens.
Configure panning to use a larger screen on the small DISPLAY.
Use remote desktop such as VNC, using vino, or module vnc, and access the desktop more comfortably on a larger workstation screen.

Downstream bug.
https://bugzilla.redhat.com/show_bug.cgi?id=710191

A patch has been proposed, but seems not to be moving.
> Rui Matos 2011-07-02 08:10:36 EDT
>
> This a bug in the X server. I've submitted a patch upstream[1] but it's still
> waiting review.
>
> [1] http://lists.x.org/archives/xorg-devel/2011-June/023715.html

xorg-x11-server-Xorg-1.10.3-1.fc15.x86_64
Linux sirius.localdomain 2.6.40-4.fc15.x86_64 #1 SMP Fri Jul 29 18:46:53 UTC 2011 x86_64 x86_64 x86_64 GNU/Linux
01:00.0 VGA compatible controller: ATI Technologies Inc Mobility Radeon HD 3400 Series
radeon driver.

panning on xrandr works momentarily, then freezes the system.
xrandr 3.5 and earlier, Slackware 3.1 and later (Slackware 3.0 and earlier use
xorg.conf and panning works without xrandr.)

still present in xorg-x11-server-Xorg-1.10.4-1.fc15.x86_64

https://bugs.freedesktop.org/show_bug.cgi?id=20334
Mouse shouldn't move into area outside the monitors

somehow seems like a possible cause of this.

My particular use case is when using my Netbook (native res. 1024x600) with an external projector (native res. 1024x768) with the displays set up as clones.

I want to be able to move the mouse into the area below/above the Netbook screen and have it pan to give access to the area which is only visible on the projector screen. Currently moving the mouse to the bottom edge of the screen doesn't pan, so if, eg. while typing my edit cursor has moved into the bottom 168 pixels of the projector screen I end up typing blind on the Netbook and having to look over my shoulder at the screen behind me.

(In reply to comment #0)
> A patch has been proposed, but seems not to be moving.
> > Rui Matos 2011-07-02 08:10:36 EDT
> >
> > This a bug in the X server. I've submitted a patch upstream[1] but it's still
> > waiting review.
> >
> > [1] http://lists.x.org/archives/xorg-devel/2011-June/023715.html

Yeah, I later submitted another patch which also fixes this issue in a different way:

http://patchwork.freedesktop.org/patch/6488/

There's no action on either of them though.

RandR panning is a really niche and unloved feature which I can understand as it makes the X server more complex than it could be. The panning functionality really belongs in a client application like a compositor.

(Reply to comment #5)
> Yeah, I later submitted another patch which also fixes this issue in a
> different way:
>
> http://patchwork.freedesktop.org/patch/6488/
>
> There's no action on either of them though.
>
> RandR panning is a really niche and unloved feature which I can understand as
> it makes the X server more complex than it could be. The panning functionality
> really belongs in a client application like a compositor.

I tried the patch and it works with panning, but not for scaling.
Ex. xrandr --output LVDS1 --scale 1.5x1.5

With scaling, the mouse is still confined to the native resolution's bounds.

http://patchwork.freedesktop.org/patch/6217/
http://patchwork.freedesktop.org/patch/6209/
I like the much more the approach in the above, as it tries to harness whatever the benefits claimed by adherents of mouse-bound check, may be.

I noticed the comment 'v2: Since crtc_bounds() is called a lot ...' means that the crtc_bounds() is called several times perhaps by mouse bound check code.
and speculate if that the reason for the alternate approach of disabling bound checking if panning is configured ?
am seeing code on
http://cgit.freedesktop.org/xorg/xserver/tree/randr/rrcrtc.c

I was wondering if the compute once, query many paradigm can be employed here.
as the crtc bounds change only when some event changes the screen size.
so crtc_bounds() may return a pre-computed bound per CRTC
and maybe a crtc_bounds_compute() is invoked to recompute only when the pre-computation has become stale.

Also, I just wish to point out, while its nice to fix panning and scaling together, it is not necessary. The use cases for those needing scaling fixed may be different, and can be incrementally fixed with another patch and bug report.

please ignore, if I don't make sense, as I'm just a just user, not developer.

Marking as a regression in 1.11.

Can someone please share if you've got a patch that fixes the scaling too? Thnx.

*** Bug 40063 has been marked as a duplicate of this bug. ***

Reverting the patch mentioned in Bug 40063 fixes it with both panning and scaling. It's a temporary fix for those of using netbooks.

How to build:
* yumdownloader --source xorg-x11-server-Xorg
* rpm -ivh xorg-x11-server-Xorg*rpm
* unzip and revert patch in the xorg .tar.bz2 and re-package it again
* go to $HOME/rpmbuild/SPECS directory and run rpmbuild -bb xorg-x11-server.spec
* re-install the fixed package: yum --nogpgcheck reinstall $HOME/rpmbuild/RPMS/*/xorg-x11-server-Xorg-1.11.1-1.fc16.x86_64.rpm

It looks like I have this problem here too (jcristau pointed me at this bug report), though with a different symptom.

I have two monitors – one 1920×1080 and one 1280×1024, set up so that I have a wide desktop area, the wider viewport at (0,0) and the narrower one at (1920,0). Trying to move to the workspace below the current one via the smaller monitor (using xfwm4's workspace switching via pointer position) fails.

However, if I move its viewport such that the two are disjoint, all works as expected.

(That said, I do agree that constraining the pointer in this way is not a bad thing.)

I'm having the exact same problem too. If anyone has some step by step instructions on how to downgrade xorg using Ubuntu 11.10 I'd be greatly appreciative.

Created attachment 56408
Reverts commit 56c90e29f04727c903bd0f084d23bf44eb1a0a11, applies cleanly to xorg-server 1.11.4

The commit referenced by Bug 40063 no longer reverses cleanly against xorg-server version 1.11.4. Attached is an updated patch that should work.

Is there any motion on getting this fixed in a current release? Panning is extremely useful to lots of laptop users. I see it listed as a blocker for 1.12, yet a fix doesn't seem to have made it into 1.12.

Please send your patch to xorg-devel for discussion.

I use xrandr for scaling to make a small netbook screen able to display apps that don't fit in 1024x600 and noticed this regression over the last year in 1.11. I finally decided to look closer since 1.12 didn't seem to fix the issue and came across this report.

I looked at the revert commit to get idea of area that could possibly be fixed and it seems like crtc_bounds() is probably a function that should be returning a value related to panning/scaling.

I traced were xrandr output is querying the panning/scaling values it displays and looks like comes from ProcRRGetCrtcInfo() and that function makes use of RRCrtcGetScanoutSize() to scaling width/height to correct size. Panning uses rrGetPanning().

To test the idea, I modified crtc_bounds to handle scaling case by adding ProcRRGetCrtcInfo() call. It does seem to work and I've not noticed a negative in limitted testing.

I patched a source RPM so I can't offer a real patch right now but here is my modified version of function to get an idea:

static void
crtc_bounds(RRCrtcPtr crtc, int *left, int *right, int *top, int *bottom)
{
    int width, height;
    RRCrtcGetScanoutSize (crtc, &width, &height);

    *left = crtc->x;
    *top = crtc->y;

    switch (crtc->rotation) {
    case RR_Rotate_0:
    case RR_Rotate_180:
    default:
       *right = crtc->x + width;
       *bottom = crtc->y + height;
       return;
    case RR_Rotate_90:
    case RR_Rotate_270:
       *right = crtc->x + height;
       *bottom = crtc->y + width;
       return;
    }
}

I reviewed the other patchwork patches just now. Patch 6209 in Comment 7 addresses panning part of issue in crtc_bounds() using same logic from ProcRRGetCrtcInfo().

If you combine my modification from Comment 17 with the patch 6209 then you'll get solution for both scaling and panning.

Not sure its the right solution and it seems a little excessive to compute each X/Y movement... but I hope it helps move us along to final solution.

Chris, could you put together the combined patch you mentioned and send it to xorg-devel for review? Thanks.

Created attachment 59557
Sample fix for panning/scaling

Attached patch has been posted to mailing list for discussion but no replies so far. Posting here so it doesn't get lost.

This combines fix for panning from another patch and adds scaling fix as well.

Just confirming that Chris Bagwell's scaling approach (above) worked for me using 1.12.0 (from Fedora 17 source rpm) and having had this issue for some time. Previously, I'd been downgrading, as I've found this an important feature for netbook usability. Thanks Chris!

Would also like to confirm that Chris Bagwell's patch works for me. I'm using 1.11.4 from Debian Sid and the patch didn't apply cleanly (whitespace issue and started at 297 instead of 282), but after I fixed that it works like a charm. Been missing this feature for a while :) Thanks Crhis!

Will give this patch a try on Xubuntu 12.04 when I have a chance. Currently, am using Mint 9 Xfce on my Lenovo S10 netbook, as the version of xrandr does not have this problem on that distro. Would love to upgrade though...

For the record, openSUSE Factory (devel) is currently @ 1.12.2, where panning for me is working OK with radeon/rv200, but not with nouveau or intel drivers.

FWIW: I don't try to use randr directly to set up panning. I do it either through xorg.conf or xorg.conf.d/50-monitor.conf because I'm usually controlling DPI via DisplaySize, limiting VertRefresh to 60 or 75, turning DPMS & DDC off, and turning DefaultModes on. It would be nice if TargetRefreshRate ever worked.

I don't use small displays either. Mostly I use CRTs as described on http://lists.x.org/archives/xorg-devel/2012-June/031652.html

Tried Chris's patch on an Acer netbook (Intel video), Debian Wheezy, and it fixed panning (xrandr) for gnome3 and xfce4. Thanks!

In previous comment for for Wheezy, the debian xorg-server source package was version: 2:1.12.1.902-1

I was also able to test the patch on Ubuntu Precise, source package version: 2:1.11.4-0ubuntu10.3. On the same Acer netbook (Intel video), it fixed xrandr panning with Unity 3D.

ps. The patch file did not apply (with patch program) to the Ubuntu source version. I applied the patch manually, with a text editor.

https://bugzilla.novell.com/show_bug.cgi?id=771521 explains how panning works for me using Radeon but not Intel or Nouveau.

Chris' patch applied nicely against 1.12.3 and solved the issue here.

I applied Mr. Bagwell's patch to Fedora 17 after receiving some guidance from Mr. Weir. I thank all who have posted for their contribution in resolving this long term regression.

My specific steps were...

1. Obtain the source: yumdownloader --source xorg-x11-server-common.i686

2. Extract the RPM to a subdirectory structure (in my case, ~/source/xorg-x11-server-x.xx.x-y.fc17.src)

3. Extract the xorg-server-x.xx.x.tar.bz2 file (contained in the directory created in step 2) to source subdirectories of that directory (in my case ~/source/xorg-x11-server-x.xx.x-y.fc.src/xorg-server-x.x.xx) created in step 2.

4. Modify the rrcrtc.c source code in the randr subdirectory (~/source/xorg-x11-server-x.xx.x-y.fc.src/xorg-server-x.x.xx/randr) as Chris states. I had to apply the patch manually, however it's very straightforward.

The following steps were issued from within the xorg-server-x.xx.x subdirectory created in step 3 above and presume you have all required development tools installed.

5. Command: ./configure --prefix=/usr.

6. Command: make

7. Command: sudo make install

I performed these steps on version 1.12.2-2 as well as on 1.12.2-4 and after testing each patch, I reinstalled (yum reinstall xorg-x11-server-common.i386) standard code to verify repeatability. In each case, scanning/panning was enabled following application of the patch.

I am running this on an Acer Aspire AOD257 which has (of course) an integrated trackpad. One issue I have noticed is that after application of the patch, the trackpad scrolling functions are disabled. That is to say, the trackpad continues to function as a "mouse", but the "finger drag along the right side of the trackpad" no longer functions. Under touchpad-system settings (KDE desktop), the touchpad information indicates "device not found". I cannot explain the relationship between this function and the patch, but will do more testing -- has anyone else on a netbook noticed this condition?

Thanks Chris for your patch "Sample fix for panning/scaling".

openSUSE Linux users can test Xorg server (package xorg-x11-server) with this patch included. openSUSE users find the temporary and experimental openSUSE repository here:

http://download.opensuse.org/repositories/home:/bjoernv:/branches:/openSUSE:/12.2:/Update/standard/

I find the old panning feature very useful. With an old "ATI Radeon Mobility 9200" graphics card, I can extent the 1024x768 desktop until 4096x4096. With an more recent "ATI Radeon HD 3450" I can extend until 8192x8192.

Unfortunately the support for panning within the KDE desktop poor. I miss special maximize and fullscreen functions for big virtual screen.

My xrandr setting for testing (3072x768 virtual desktop on a 1024x768 Laptop (LVDS) screen):

xrandr --output LVDS --panning 3072x768

I have no problems with touchpad and external mouse.

(In reply to comment #31)
> http://download.opensuse.org/repositories/home:/bjoernv:/branches:/openSUSE:/
> 12.2:/Update/standard/

As indicated in downstream https://bugzilla.novell.com/show_bug.cgi?id=771521 these work for me with Intel 865G and NVidia G84.

Has this fallen off the radar? I'd like to update my system, but I can't lose this functionality.

I wonder, why the maximum panning size is so driver dependent.

My ATI Radeon HD 3450 had a maximum panning size of 8192x8192 with the open source "radeon" and "radeonhd" drivers. With AMD's ATI Catalyst 13.1 Legacy driver I only have a maximum of 1920x1920. The monitor's native size is Full-HD (1920x1080) and it's connected via Dual-Link-DVI.

$ xrandr -q
Screen 0: minimum 320 x 200, current 1920 x 1080, maximum 1920 x 1920
DFP1 connected 1920x1080+0+0 (normal left inverted right x axis y axis) 510mm x 287mm panning 1920x1080+0+0
   1920x1080 60.0*+
   1776x1000 60.0 +
   1680x1050 60.0
[...]

One possible answer to my own question is, that AMD's ATI Catalyst driver disables the Xorg RandR extension and enables it's own RandR extention:

from /var/log/Xorg.0.log:
[...]
[ 68.714] (II) fglrx(0): RandR 1.2 support is enabled!
[ 68.714] (II) fglrx(0): RandR 1.2 rotation support is enabled!
[...]
[ 69.541] (II) fglrx(0): Disabling in-server RandR and enabling in-driver RandR 1.2.
[ 69.975] (--) RandR disabled
[...]
[ 69.975] (II) Initializing built-in extension RANDR
[...]
[ 92.101] (II) fglrx(0): Restoring Recent Mode via PCS is not supported in RANDR 1.2 capable environments

Any idea, how to change this configuration?

If it hasn't happened already, the supply of supported distros that feature working panning should be exhausted soon. Is there anything non-programmers can do to facilitate a programmer fixing this?

Has anyone bugged keithp to review the proposed patch? I'm pretty sure he could do so quickly, and suggest an alternate if needed.

(In reply to comment #37)
> Has anyone bugged keithp to review the proposed patch? I'm pretty sure he
> could do so quickly, and suggest an alternate if needed.

If you'll tell me who keithp is, I'll bug him.

(In reply to comment #38)
> If you'll tell me who keithp is, I'll bug him.

Maintainer of the xorg-server.

He mostly reviews fixes sent to xorg-devel, not those stuck in bugzilla though.
http://www.x.org/wiki/Development/Documentation/SubmittingPatches/

I have this bug when I use xrandr to resize the output to the VGA monitor, and then turn off the LVD using xrandr --output LVDS1 --off. The mouse becomes confined to the left side of the monitor as soon I turn off the LVD.

I have version 2:1.11.4-0ubuntu10.13 of xorg-server, where this problem is supposed to be fixed for the LVD, but evidently it is not fixed for the VGA.

It seems clear that at least analog hardware users who require panning and want or need to stick to FOSS solutions need to stick to out of support Xorg versions and/or out of support drivers, and/or ancient gfxchip technology (e.g. MGA), and/or cheap (and usually slow) hardware (e.g. # XGI Technology Inc. (eXtreme Graphics Innovation) Z7/Z9 (XG20 core), a slug at 24 bit, tolerable at 16 bit as long as not extending the desktop virtually as panning was made to do). It looks like users of supported FOSS software versions and modern competent gfxchips are out of options other than acquiring (digital?) displays big enough, or acquiring additional (digital?) video ports and (digital?) displays, to cover their otherwise virtual needs.

Created attachment 94929
randr: Account for panning and transforms when constraining the cursor

Created attachment 96204
Xorg.0.log from 92915G host gx280

http://download.opensuse.org/repositories/home:/tobijk:/X11:/XOrg/openSUSE_Factory/i586/ ostensibly has the attachment 94929 patch applied, which I installed on nv11, rv250 and i915G systems running X.Org X Server 1.15.99.901.

# rpm -q --changelog xorg-x11-server | head -n8
* Fri Mar 21 2014 tobias.johannes.klausmann@...
- Add patch u_randr_account_for_panning_and_transform_when_creating_cursor.patch
  (patch230)
  (BNC#771521), (FDO#39949)

I could not detect any difference before or after installing the xorg-x11-server version 7.6_1.15.99.901.8-393.1 that includes the patch, plus its dependencies. IOW, pointer could not reach right or bottom screen edges before or after installing with any of the ati, intel or nouveau drivers.

Ati and nouveau test logs are available on request.

Comment 43 applies to use of xorg.conf in attempting to produce desired X configuration, e.g. xorg.conf for Intel gfx containing:

Section "Device"
    Identifier "Default Device"
 Option "monitor-VGA1" "Default Monitor"
EndSection

Section "Monitor"
    Identifier "Default Monitor"
 Option "DPMS" "off"
 DisplaySize 405 253 # 120 DPI @ 1920x1200 & virtual
 Option "PreferredMode" "1440x900"
 Option "Panning" "1920x1200"
EndSection

Section "Screen"
    Identifier "Default Screen"
 Device "Default Device"
 Monitor "Default Monitor"
EndSection

produces expected results for server 1.9.3, but not for server 1.16.0RC1. Functional panning matching that produced by the above xorg.conf can be at least mostly achieved in i915 via xrandr as follows:

xrandr --dpi 120 --fb 1920x1200 --output VGA1 --mode 1440x900 --panning 1920x1200
 or
xrandr --fbmm 405x253 --fb 1920x1200 --output VGA1 --mode 1440x900 --panning 1920x1200

A remaining problem therefore exists that did not exist prior to the server changes made that made this bug report necessary in the first place, that xorg.conf no longer does what xrandr can, as xorg.conf used to be able to do. This is new with the 96204 patch, as with the 56408 patch and server 1.12.3, xorg.conf gets the job done as expected.

Created attachment 96397
Xorg.0.log from i915 host gx280 having used xrandr to produce panning from 94929 patch

This seems to be unusually verbose for the brief time X was running, with few apps opened.

Via xrandr, 94929 patch also tested working apparently OK for:
ATI rv380 VGA & DVI ports 1680x1050 on 1280x1024
Intel G41 VGA & HDMI ports 1680x1050 on 1280x1024
Nouveau G84 DVI port 1680x1050 on 1280x1024. with & without DVI-to-VGA adapter
Nouveau G84 DVI port 2048x1152 & 2560x1600 & 3840x2160 on 1440x900 with DVI-to-VGA adapter

With the g84 on 1080 HDTV, apparently scaling, which I never tried before, is working too:
$ xrandr --output DVI-I-1 --scale 1.2x1.2
(Assorted X data collected via script):
# grep PRETTY /etc/os-release
PRETTY_NAME="openSUSE 13.2 Milestone 0 (Harlequin) (x86_64)"
# head -n16 /var/log/Xorg.0.log (beta warning stripped)
[ 31.305]
X.Org X Server 1.15.99.901 (1.16.0 RC 1)
Release Date: 2014-02-24
[ 31.305] X Protocol Version 11, Revision 0
[ 31.305] Build Operating System: openSUSE SUSE LINUX
[ 31.305] Current Operating System: Linux big41 3.14.0-rc7-1-desktop #1 SMP PREEMPT Thu Mar 20 12:43:03 UTC 2014 (89fa272) x86_64
[ 31.305] Kernel command line: root=LABEL=os132h50 ipv6.disable=1 net.ifnames=0 noresume splash=verbose vga=791 video=1024x768@60
# grep Output /var/log/Xorg.0.log | egrep -v 'disconnected|no monitor'
[ 31.653] (II) NOUVEAU(0): Output DVI-I-1 connected
[ 31.653] (II) NOUVEAU(0): Output DVI-I-1 using initial mode 1920x1080
# grep -v ^\# /etc/X11/xorg.conf.d/50-monitor.conf | grep DisplaySize
grep: /etc/X11/xorg.conf.d/50-monitor.conf: no such file or directory
# grep -v ^\# /etc/X11/xorg.conf | grep DisplaySize
grep: /etc/X11/xorg.conf: no such file or directory
# grep -v ^\# /etc/X11/xorg.conf.d/50-monitor.conf | grep PreferredMode
grep: /etc/X11/xorg.conf.d/50-monitor.conf: no such file or directory
# grep -v ^\# /etc/X11/xorg.conf | grep PreferredMode
# xrdb -query | grep dpi
grep: /etc/X11/xorg.conf: no such file or directory
# xdpyinfo | egrep 'dime|ution'
  dimensions: 2304x1296 pixels (608x342 millimeters)
  resolution: 96x96 dots per inch
# xrandr | head
Screen 0: minimum 320 x 200, current 2304 x 1296, maximum 8192 x 8192
DVI-I-1 connected 2304x1296+0+0 (normal left inverted right x axis y axis) 698mm x 393mm
   1920x1080 60.0*+ 60.0 59.9 24.0 24.0
   1920x1080i 60.1 60.0
   1280x720 60.0 59.9
   1024x768 75.1 70.1 60.0
DVI-I-2 disconnected (normal left inverted right x axis y axis)

For well over a week I've been first testing the success of panning for various combinations of gfxcard, monitor and fb size in servers prior to the changes resulting in this bug report and then same for installations to which I've updated using the 94929 patch applied by Tobias Klausmann in the openSUSE build-service. Initially the only recording I did of my testing I reported here. After while I began recording in the form of screenshots accompanied by the Xorg.#.log associated with each one. These are available for perusal at http://fm.no-ip.com/SS/Xorg/ . Among them is one instance of a scaling test, 1.2x1.2 applied to a 1440x900 screen. The largest fb size I tested was 3840x2400. The newest gfxchip used was a Intel 4000 series (G41). Others used are nv11, G84, rv200, rv250, rv380, i865G, i915G & i945G. The highest resolution used was 1920x1080. Total "success" pairs there currently is 31, of which 14 are pre-bug and 17 are server 1.16rc1. KDE3 & KDE4 dominate the DEs represented. A few are IceWM and Lxde.

The only outright failure so far was on i945G and 1.16rc1 on both openSUSE 13.1 & 13.2, but after another system/xorg updates round those inexplicable failures apparently solved themselves.

Among the overwhelming number of "successes" are many instances of various forms of painting and mouse pointer trouble among the configurations with the largest panning areas that always goes away if panning is disabled. However, such problems are common to both old servers and DEs as well as current ones. The painting problems don't show up in any of the screenshots. Except for the comment 44 reported failure of xorg.conf* to produce expected results, WRT to bounds and sizes at least, the 94929 patch seems to be doing what it needs to do.

(In reply to comment #42)
> Created attachment 94929 [details] [review]
> randr: Account for panning and transforms when constraining the cursor

Chris, any plans to send this patch to the xorg-devel list, i.e. to get this upstream or is that just a proof of concept?

As the summary is currently written, this bug is INVALID. Panning works at least as far back as 1.13.2-1.21.1.i586 in openSUSE 12.3 (i865G,rv200), in addition to current 1.15.x and 1.16rc1 servers in Fedora, Mageia, and openSUSE, but only when xrandr is used to configure it. Configuration via /etc/X11/xorg.con* files and syntax that worked in older servers such as 1.10.4 is what is broken for ATI, Intel and NVidia.

I haven't tested scaling except briefly, and successfully, via xrandr only, in e.g. 1.16rc1.

Panning works via xrandr (only; not via xorg.con*) also in Kubuntu 12.04's server 1.11.4, while scaling does fail by having the mouse cursor bound within the screen mode's size.

Since panning at least can work via xrandr, I've forked the failure of xorg.con* to provide equivalent panning function of xrandr without arbitrary mouse constraint to bug 77321

Probably this bug has been marked invalid because there is a mix of two bugs here: one is related to panning (which I do not know if it's fixed or no), and the other one to mouse constraints when scaling.

I have X.Org X Server 1.14.5 , and if I issue

xrandr --output LVDS1 --scale 2x2

the screen scales correctly, but then the mouse is restricted to the (original 1x1 viewport) upper left quarter of the screen, making the scaling completely unuseful.

It is quite easily reproducible.

Totally agree.

So perhaps this could be renamed to something like "Xrandr scaling does not
scale the mouse pointer area" or be splitted to a different bug report.
On Apr 21, 2014 4:26 PM, <email address hidden> wrote:

> *Comment # 53 <https://bugs.freedesktop.org/show_bug.cgi?id=39949#c53>
> on bug 39949 <https://bugs.freedesktop.org/show_bug.cgi?id=39949> from
> Romano Giannetti <email address hidden> *
>
> Probably this bug has been marked invalid because there is a mix of two bugs
> here: one is related to panning (which I do not know if it's fixed or no), and
> the other one to mouse constraints when scaling.
>
> I have X.Org X Server 1.14.5 , and if I issue
>
> xrandr --output LVDS1 --scale 2x2
>
> the screen scales correctly, but then the mouse is restricted to the (original
> 1x1 viewport) upper left quarter of the screen, making the scaling completely
> unuseful.
>
> It is quite easily reproducible.
>
> ------------------------------
> You are receiving this mail because:
>
> - You are on the CC list for the bug.
>
>

(In reply to comment #53)
> Probably this bug has been marked invalid because there is a mix of two bugs
> here: one is related to panning (which I do not know if it's fixed or no),
> and the other one to mouse constraints when scaling

This bug has not been marked invalid.

> I have X.Org X Server 1.14.5 , and if I issue

> xrandr --output LVDS1 --scale 2x2

> the screen scales correctly, but then the mouse is restricted to the
> (original 1x1 viewport) upper left quarter of the screen, making the scaling
> completely unuseful.

That's why the summary says doesn't "work". Unuseful and doesn't work are functionally equivalent ways of saying it is broken (constrained mouse) and thus not providing function (able to reach all areas of screen with mouse) that makes it usable (can't click mixer icon on panel).

Why is this bug still in the NEEDINFO state? I.e. what info is needed before someone reviews the patch?

The bug is also relevant to scaling. You can test it (assuming a 1920x1200 monitor) with the following example commands:

xrandr --fb 3840x2400
xrandr --output DVI-I-1 --scale 2x2

The example has no purpose as written, except to illustrate the bug, but similar "xrandr --scale" commands are useful if one wants to mirror a 1366x768 laptop screen and a 1920x1080 projector for a presentation.

(In reply to comment #56)
> Why is this bug still in the NEEDINFO state? I.e. what info is needed before
> someone reviews the patch?

Worth repeating...
Why is this bug still in the NEEDINFO state?

I too can confirm that scaling doesn't work with radeon.

On a laptop with intel driver, the following works fine, except the mouse pointer is confined to the mode area, but I believe that is a known xorg-server bug:
xrandr --fb 1920x1080 --output eDP1 --mode 1600x900 --scale-from 1920x1080

The same command, adapted to the radeon output device doesn't work. Same software configuration (xorg-1.15.99.903, libdrm-git, mesa-git, xf86-video-ati-git, various kernel versions (at the moment 3.15.2)). Screen rotation does work, though.

The patch from attachment #94929 solves the issues with constraining the mouse pointer, so everything works fine on intel. I will file a separate bug for the radeon driver.

(In reply to comment #58)
> Why is this bug still in the NEEDINFO state?

Because there are approximately zero active Xorg developers with enough
time to keep up on bugzilla. Patches mailed to the xorg-devel mailing
list may get reviewed & applied faster, as described on:
http://wiki.x.org/wiki/Development/Documentation/SubmittingPatches/

Today I talked about this bug with Keith Packard. As a result of our testing, I have to state that, with the patch, the pointer is not constrained properly on the right side if one applies keystone correction. That's with xorg-server 1.16.1, will now retest with the latest git.

Retested with the latest git. The patch indeed breaks constraining the mouse on the right side when keystone correction is active. However, the whole "keystone correction" feature is already so horribly broken that I'd just propose to drop it.

The breakage is that, if you click something, the click will not go into a point that you intended to click. I.e. you can't even undo the damage using the xkeystone GUI.

Tested modified Chris Wilson's patch with 1.16.0 on Ubuntu, works (no keystone).
https://bugs.launchpad.net/ubuntu/+source/xorg-server/+bug/883319/comments/112

With the proliferation of hidpi laptops having scale properly working is becoming more important since it is the only way of using embedded and external displays with a decent experience.

I do not know for what keystone is used these days but, maybe we could consider breaking it in favor of scale?

We can't wait until Wayland + al Compositors to implement scaling imho.

Thanks.

(In reply to Alex Fiestas from comment #65)
> With the proliferation of hidpi laptops having scale properly working is
> becoming more important since it is the only way of using embedded and
> external displays with a decent experience.
>
> I do not know for what keystone is used these days but, maybe we could
> consider breaking it in favor of scale?
>
> We can't wait until Wayland + al Compositors to implement scaling imho.
>
> Thanks.

Seconded. Chris's patch has been around for over a year. A second screen attached to a HiDPI laptop is now a far more common use case than pre-output keystoning.

If necessary we could open a new ticket (this has been suggested before) to isolate the scaling issue.

James

James, better create new bug ticked for it...

Can someone please help me to port this little patch to xorg-1.17.2?

https://bpaste.net/show/dc939e359a3f

This is part of the Ubuntu patch updated against 1.16.

I suggest you ask on xorg-devel about your patch.

fish (discordianfish) on 2016-05-10
description: updated
Timo Aaltonen (tjaalton) on 2016-05-10
Changed in xorg-server (Ubuntu):
assignee: nobody → Timo Aaltonen (tjaalton)
status: New → Triaged
fish (discordianfish) wrote :

I've tried tjaalton's build with the patch from https://bugs.freedesktop.org/attachment.cgi?id=94929 and while it fixes the problem, it causes a segfault after a few seconds: https://gist.github.com/discordianfish/e91a463ef66ba9dbb3a86f14fc43c129

fish (discordianfish) wrote :

Just upgraded my system and the problem seems to be solved. But I'm a bit confused regarding the package versions. Is there a -1ubuntu2 and -1ubuntu2.0? Because later is what is installed now:

$ apt-cache policy xserver-xorg-core
xserver-xorg-core:
  Installed: 2:1.18.3-1ubuntu2.0

And the log shows that it was upgraded:

2016-05-17 10:08:54 configure xserver-xorg-core:amd64 2:1.18.3-1ubuntu2.0 <none>
2016-05-17 10:08:54 status unpacked xserver-xorg-core:amd64 2:1.18.3-1ubuntu2.0
2016-05-17 10:08:54 status half-configured xserver-xorg-core:amd64 2:1.18.3-1ubuntu2.0
2016-05-17 10:08:54 status installed xserver-xorg-core:amd64 2:1.18.3-1ubuntu2.0

Either way, I'm not affected by this issue anymore.

Timo Aaltonen (tjaalton) wrote :

so what was that segfault about?

fish (discordianfish) wrote :

@tjaalton: OH oops. Yes just realize this package is from your ppa. Hrm looks like it's work now. Maybe the segfault was caused by another package it depends on? At least right now things look stable. Will report back if that changes.

If you are still experiencing this bug using a non ppa package, please set this bug status back to "confirmed".

Changed in xorg-server (Ubuntu):
status: Triaged → Fix Released
fish (discordianfish) wrote :

I think there was a misunderstanding. The ppa works for me now, the segfault is gone. The Non-ppa package still has the issue described above.

fish (discordianfish) on 2016-06-27
Changed in xorg-server (Ubuntu):
status: Fix Released → Confirmed

Not to bug you guys ;-), but as we are on the road to christmas in 2016 ...
Any news? Is there another bug ticket? Is status "NEEDINFO" still valid?
Does anyone really needs info I or someone else can provide?

No news, the bug is still reproducible, and it is not clear what information is needed.

AFAICT, nobody has followed my direction above and brought this up for discussion on xorg-devel. Without that, it's not likely to be fixed.

Broken panning, Bug 77321 , got a downstream fix 5 months ago in
https://bugzilla.opensuse.org/show_bug.cgi?id=771521

Changed in xorg-server (Ubuntu):
importance: Undecided → Critical

if I'm reading things correctly, this is what suse added

https://bugzilla.opensuse.org/attachment.cgi?id=661954&action=diff&context=patch&collapsed=&headers=1&format=raw

which is not what has been proposed here so far

Changed in xorg-server (Ubuntu):
importance: Critical → Medium

(In reply to Timo Aaltonen from comment #74)
> if I'm reading things correctly, this is what suse added
>
> https://bugzilla.opensuse.org/attachment.
> cgi?id=661954&action=diff&context=patch&collapsed=&headers=1&format=raw
>
> which is not what has been proposed here so far

Egbert still plans to bring this patch/topic up on xorg-devel for discussion, so things hopefully won't get lost.

As noted in https://bugs.launchpad.net/xorg-server/+bug/883319/comments/62 , the fix for #883319 requires --panning to be specified with --scaling in order to disable the mouse constraints when scaling.

Ideally, xorg should be modified such that the mouse constraints are calculated based on the --scaling and --panning settings, rather than being disabled when --panning is enabled. Short of that, it would be nice if xorg was modified to disable the mouse constraints when --scaling is enabled (in addition to when --panning is enabled). If neither of those can be accomplished, it would probably be sufficient to simply document (in the man page?) that --panning may be needed to disable the mouse constraints when using --scaling.

fish (discordianfish) wrote :

I can confirm that --panning works for me. While I'm good now, I'd encourage the maintainers to consider this a severe UX issue. It's not at all intuitive that you need to change this option to make it work.
Then again, it probably makes sense to add options to the control center for changing the scale factor where it could set the right panning option transparently.

fish (discordianfish) wrote :

Ha well.. No, it was working until I moved my mouse pointer to the other screen. Now my display actually pans around. So still have found no way to get decent sizes on both displays with different DPI.

fish (discordianfish) wrote :

Sorry but this is super confusing. Is this a known issue that is being worked on or did I miss something? I've opened this issue because 883319 didn't fix it. Now I tried panning and this also didn't fix it, but that's what was described in 883319.
Willing to investigate time in debugging this but I'm really confused about the state of things right now.

Timo Aaltonen (tjaalton) wrote :

not really worked on, discussions should happen on the upstream bug if you want something concrete to happen

and I assume the suse patch didn't fix anything, just allows panning

Changed in xorg-server (Ubuntu):
assignee: Timo Aaltonen (tjaalton) → nobody
fish (discordianfish) wrote :

I'm willing to spend some time on this but really don't know how to proceed. Last comment on the upstream bug says 'Egbert', whoever that is, will discuss this on the dev mailing list. I don't know what that involves.. I mean I can also drop a mail to the list and say please, please include this patch but given how many people are involved in the issue who know more than me about this issue that seems silly.. Still, if you think that's the way to go I can just ping the mailing list.

Fwiw, I was able to build new debs like this:

- Download patch from https://bugs.freedesktop.org/attachment.cgi?id=94929
- apt-get source xserver-xorg-core
- cd xorg-server-1.18.3
- quilt import that-downloaded.patch
- quilt push
- dch -n
- debuild -b -uc -us

Will see if it fixes the issue for me.

fish (discordianfish) wrote :

So yes this fixes the issue for me, although xorg already crashed on me once with that patch applied. Will report back with details if this happens again.

Changed in xorg-server:
importance: Unknown → High
status: Unknown → Incomplete

Wow, guys. This discussion definitely took some time ;) Any update? https://www.internetvergelijken.nl/

Stefan, any news from Egbert on this? Why it takes so long

--
Brian
https://www.voucher.co.id/

I sent Chris Wilson's patch to the mailing list.

Changed in xorg-server:
status: Incomplete → Fix Released
Joseph Long (jdlong) wrote :

Will this fix be backported to 18.04 LTS when released? Apologies for not understanding the bug workflow here, but I can't find a way to indicate that I'm experiencing this bug on 18.04 LTS.

Michael Accetto (nvergontbij) wrote :

Yes! Bug present on 18.04 LTS. How can we get some attention to this?

Ivan Chernovalov (rules96) wrote :

VMWare has this cursor issue

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.